/**
 * @author dbu
 * @date 22/05/2024
 * @version 1.0.0
 * @project qualité
 * @table chroniques_analyses
 */

# --- !Ups

DROP INDEX IF EXISTS chroniques_analyses_numanalyse_idx ;
DROP INDEX IF EXISTS chroniques_analyses_numanalyse_idx1 ;
DROP INDEX IF EXISTS chroniques_analyses_codeparametre_idx;
DROP INDEX IF EXISTS chroniques_analyses_codeparametre_idx1;
DROP INDEX IF EXISTS chroniques_analyses_codequalitometre_idx;
DROP INDEX IF EXISTS chroniques_analyses_codequalitometre_idx1;
DROP INDEX IF EXISTS chroniques_analyses_pk ;
DROP INDEX IF EXISTS chroniques_analyses_pk1;
DROP INDEX IF EXISTS chroniques_analyses_codequalito_numprel_codeop_numana;
DROP INDEX IF EXISTS chroniques_analyses_codequalito_numprel_codeop_numana_codeparam;
DROP INDEX IF EXISTS chroniques_analyses_codequalito_numprel_codeop_numana_dateana;

CREATE UNIQUE INDEX chroniques_analyses_numanalyse_idx ON public.chroniques_analyses (numanalyse);
CREATE UNIQUE INDEX chroniques_analyses_pk ON public.chroniques_analyses (numanalyse, codequalitometre, codeoperation);
CREATE INDEX chroniques_analyses_codequalito_numprel_codeop_numana ON public.chroniques_analyses USING btree (codequalitometre, numprelevement, codeoperation, numanalyse);
CREATE INDEX chroniques_analyses_codequalito_numprel_codeop_numana_codeparam ON public.chroniques_analyses USING btree (codequalitometre, numprelevement, codeoperation, numanalyse, codeparametre);
CREATE INDEX chroniques_analyses_codequalito_numprel_codeop_numana_dateana ON public.chroniques_analyses USING btree (codequalitometre, numprelevement, codeoperation, numanalyse, dateanalyse);
CREATE INDEX chroniques_analyses_codeparametre_idx ON public.chroniques_analyses USING btree (codeparametre);
CREATE INDEX chroniques_analyses_codequalitometre_idx ON public.chroniques_analyses USING btree (codequalitometre);

# --- !Downs
