/**
 * @author jroba
 * @date 21/04/2022
 * @version 1.0.0
 * @project Iryqua
 * @table agri_prel_volumes
 */

# --- !Ups

create or replace function doEvolution245()
    RETURNS double precision
    LANGUAGE plpgsql
as $BODY$
begin
    IF (EXISTS(SELECT *
                FROM INFORMATION_SCHEMA.TABLES
                WHERE TABLE_NAME = 'agri_prel_volumes') is false) then
        create table agri_prel_volumes(
            idexploitation          bigint,
            codeinstallation        bigint,
            anneedemande            integer,
            idenquete               bigint,
            volumedemande           real,
            volumeattribue          real,
            commentaireattribution  text,
            loginattribution        varchar(50),
            dateattribution         timestamp with time zone,
            volumeautorise          real,
            commentaireautorisation text,
            loginautorisation       varchar(50),
            dateautorisation        timestamp with time zone
        );;
        ALTER TABLE agri_prel_volumes ADD COLUMN debitAutorisation real;;
        ALTER TABLE agri_prel_volumes ADD COLUMN volumeDemandeEtiage real;;
        ALTER TABLE agri_prel_volumes ADD COLUMN volumeAttribueEtiage real;;
        ALTER TABLE agri_prel_volumes ADD COLUMN volumeAutorisEtiage real;;
        alter table agri_prel_volumes add idusageprevi bigint;;
        alter table agri_prel_volumes alter column loginattribution type varchar(50) using loginattribution::varchar(50);;

        alter table agri_prel_volumes alter column loginautorisation type varchar(50) using loginautorisation::varchar(50);;
    end if;;
    return 0;;
end;;
$BODY$;;
select doEvolution245();;

# --- !Downs
